/***************************************************************************
                          itview.cpp  -  description
                             -------------------
    begin                : ven avr 25 2003
    copyright            : (C) 2003 by Christophe Gros
    email                : skylendar@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "itview.h"
#include "interceptor.h"
#include <qmutex.h>
#include <kglobal.h>
#include <klocale.h>
#include <qlistview.h>
#include <qpixmap.h>
#include <qapp.h>

extern const QString* iFptr;
extern const QPixmap *PInfo, *PWarn, *PCrit;

ItView::ItView(Interceptor* it,  bool redir) : _ItView(0, "ItView", 1)
{
	It = it;
	Count = 0;
  if(redir)
    setCaption( tr2i18n( "Redirected Log View" ) );
	List->setSorting(-1);	
}

ItView::~ItView()
{
}
void ItView::getLine(const LogLine* l)
{
  QListViewItem* qlvi;
	QString qs = KGlobal::locale()->formatDate(l->Date, TRUE);
	qs +=  " " + KGlobal::locale()->formatTime(l->Time, TRUE);
	if(Count)
		qlvi = new QListViewItem(List, List->lastItem(), iFptr[l->Level], l->Source, l->Host, l->Text, qs);
	else
		qlvi = new QListViewItem(List, iFptr[l->Level], l->Source, l->Host, l->Text, qs);
	Count++;
	if(Count > It->NbLines)
	{
		 delete List->firstChild();
	}
  switch(l->Level)
  {
    case Debug:
    case Info:
    case Notice: qlvi->setPixmap(0, *PInfo); break;
    case Warning:
    case Err:    qlvi->setPixmap(0, *PWarn); break;
    default:;    qlvi->setPixmap(0, *PCrit);
  };
}
