/***************************************************************************
                          prefs.cpp  -  description
                             -------------------
    begin                : sam avr 26 2003
    copyright            : (C) 2003 by Christophe Gros
    email                : skylendar@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "prefs.h"
#include "interceptor.h"
#include "qlistview.h"
#include <qlineedit.h>
#include <qcombobox.h>
#include <kglobal.h>
#include <klocale.h>
#include <kconfig.h>
#include <kcolorbutton.h>
#include <qspinbox.h>

static const char* Action[] = {" None", "Beep", "Message", "Redirect", "Run" };
static const char* IconNames[] = {"Level", "Floppy", "CDROM", "CDRW", "DVD", "HD", "Printer", "Scanner", "Network", "Socket" };
extern MaList MaList;

Prefs::Prefs(Interceptor* it) : _Prefs(0, "Prefs", 1)
{
	Qlvi = 0;
	It = it;
	{
   QMutexLocker qml(&MaList);
   MessAction* ma;
   for(ma = MaList.first(); ma; ma = MaList.next())
   {
		 new QListViewItem(List, Action[ma->action], IconNames[ma->Icon], ma->PatStr, ma->Arg1, ma->Arg2);
	 }
	}
	Col0->setColor(It->Cols[0]);
	Col1->setColor(It->Cols[1]);
	Col2->setColor(It->Cols[2]);
	emit NbLines->setValue(It->NbLines);
	emit NbDialogBox->setValue(It->MaxNbDB);
}

Prefs::~Prefs(){
}

void Prefs::OkSlot()
{
	int j;
	QString ru, li;
	QListViewItem* qlvi;
	{
   QMutexLocker qml(&MaList);
   MaList.clear();
   It->ksConfig->deleteGroup("Rules");
   It->ksConfig->setGroup("Rules");
   for(qlvi = List->firstChild(), j = 0; qlvi; qlvi = qlvi->nextSibling(), j++)
   {
		 int l = 0, icon = 0;
		 const QString &d = qlvi->text(0), &iname = qlvi->text(1);
		 for(int i = MessAction::None; i <= MessAction::Run; i++)
			 if(d == Action[i])
				 l = i;
		 for(int i = 0; i < NBICONS - 2; i++)
			 if(iname == IconNames[i])
				 icon = i;
     MaList.append(new MessAction((enum MessAction::Action)l, icon, qlvi->text(2), qlvi->text(3), qlvi->text(4)));
     ru.sprintf("Rule%d", j);
     li.sprintf("%s,%s,%s,%s,%d", Action[l], qlvi->text(2).data(), qlvi->text(3).data(), qlvi->text(4).data(), icon);
     It->ksConfig->writeEntry(ru, li);
    }
    if(It->ksConfig->hasGroup("General"))
    {
		 It->ksConfig->setGroup("General");
		 It->ksConfig->writeEntry("Col0", Col0->color());
		 It->Cols[0] = Col0->color();
		 It->ksConfig->writeEntry("Col1", Col1->color());
		 It->Cols[1] = Col1->color();
		 It->ksConfig->writeEntry("Col2", Col2->color());
		 It->Cols[2] = Col2->color();
		 It->ksConfig->writeEntry("NbLines", NbLines->value());
		 It->NbLines =  NbLines->value();
		 It->MaxNbDB = NbDialogBox->value();
		}
  }
  It->ksConfig->sync();
  It->ksConfig->rollback();
  accept();
}	

void Prefs::CancelSlot()
{
	reject();
}

void Prefs::NewSlot()
{
	Qlvi = new QListViewItem(List, Action[ActionBox->currentItem() + 1], IconNames[Icons->currentItem()], Pattern->text(), Arg1->text(), Arg2->text());
}

void Prefs::ModifySlot()
{
	if(Qlvi)
	{
		emit Qlvi->setText(0, Action[ActionBox->currentItem() + 1]);
		emit Qlvi->setText(1, IconNames[Icons->currentItem()]);
		emit Qlvi->setText(2, Pattern->text());
		emit Qlvi->setText(3, Arg1->text());
		emit Qlvi->setText(4, Arg2->text());
	}
}

void Prefs::DeleteSlot()
{
	if(Qlvi)
		delete Qlvi;
	Qlvi = 0;
}

void Prefs::clicked(QListViewItem* qlvi)
{
	Qlvi = qlvi;
	const QString &d = qlvi->text(0), &iname = qlvi->text(1);
	for(int i = MessAction::None; i <= MessAction::Run; i++)
		if(d == Action[i])
			emit ActionBox->setCurrentItem(i - 1);
  for(int i = 0; i < NBICONS - 2; i++)
		if(iname == IconNames[i])
			emit Icons->setCurrentItem(i);
	emit Pattern->setText(qlvi->text(2));
	emit Arg1->setText(qlvi->text(3));
	emit Arg2->setText(qlvi->text(4));
}
